#include <windows.h>
#include <math.h>
#include <stdio.h>
#include "resource.h"

#define G 9.81          //Konstante der Fallbeschleunigung der Erde
#define STEP .000000001 //Zeitschritt

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

int V=26;  //Geschindigkeit in x-Richtung

double x=0; double y=0; //Position des Krpers
double t=0; //Zeit
double s=0; //Weg

char schrift[200];

BOOL CALLBACK DialogProcSettings(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
	const char name[]="freier Fall";

	HWND hWnd;
	MSG msg;
	WNDCLASS wc;

	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.hCursor=LoadCursor(NULL, IDC_ARROW);
	wc.hIcon=LoadIcon(NULL, IDI_APPLICATION);
	wc.hInstance=hInstance;
	wc.lpfnWndProc=WndProc;
	wc.lpszClassName=name;
	wc.lpszMenuName="menu";
	wc.style=CS_HREDRAW | CS_VREDRAW;

	RegisterClass(&wc);

	hWnd=CreateWindow(name, name, WS_POPUP, CW_USEDEFAULT, CW_USEDEFAULT, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN), NULL, NULL, hInstance, NULL);

	ShowWindow(hWnd, iCmdShow);
	UpdateWindow(hWnd);

	while(GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
};

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	static HINSTANCE hInstance;

	if((message==WM_CREATE)||(message==WM_RBUTTONDOWN))
	{
		InvalidateRect(hWnd, 0,1);
	}

	if (message==WM_DESTROY)
	{
		PostQuitMessage(0);
		return 0;
	}


	if (message==WM_PAINT)
	{		
		x=0; y=0; t=0;  //Variablen zurcksetzen

		hdc=BeginPaint(hWnd, &ps);
		while((y<GetSystemMetrics(SM_CYSCREEN))&&(x<GetSystemMetrics(SM_CXSCREEN)))
		{//solange die Parabel nicht ber den Rand geht
			t+=STEP; //Zeit erhhen
			
			s=((G)/2)*(pow(t*100,2)); //Weg fr Fallrichtung (y) berechnen...
			y+=s;               //...und dazu addieren

			s=V*t;   //Weg fr x-Geeschindigkeit berechnen...
			x+=s;	 //...und dazu addieren
	
			SetPixel(hdc, (int)x, (int)y, RGB(0,0,0)); //den Pixel anzeigen
		}
		EndPaint(hWnd, &ps);

		return 0;
	}

	if(message==WM_COMMAND) //Men
	{
		switch(LOWORD(wParam))
		{
		case(beenden): //Wenn Beenden gedrckt: Sende Nachricht "WM_DESTROY"
			SendMessage(hWnd, WM_DESTROY, 0,0);
			break;
		case(settings):
			DialogBox(hInstance, "IDD_SETTINGS", hWnd, DialogProcSettings);
			InvalidateRect(hWnd, 0, 1);
			break;
		}
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
};


BOOL CALLBACK DialogProcSettings(HWND hDlgSettings, UINT message, WPARAM wParam, LPARAM lParam)
{
	if(message==WM_INITDIALOG)
	{
		wsprintf(schrift, "%i", V);
		SetDlgItemText(hDlgSettings, ID_V, schrift);

		SetFocus(GetDlgItem(hDlgSettings, ID_V));
	}

	if(message==WM_COMMAND)
	{
		switch(LOWORD(wParam))
		{
		case(IDOK):
			GetDlgItemText(hDlgSettings, ID_V, schrift, sizeof(schrift));
			V=(atoi(schrift));
		case(IDCANCEL):
			EndDialog(hDlgSettings, 0);
			break;
		}
	}

	return FALSE;
}
